/*  File:     knoten.java 
    Project:  OOPracktikum 2001
	            Connect-Game Info Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  parser
    Autor:    Georg Martius
    Descript: Baum fr Parser fr ein String der folgenden Form
		<Knoten> 		::= <Konstruktor><Knoten> | <Liste> | <Tupel> | <Record> | <Zahl> | <String>
		<Konstruktor> 	::= Bezeichner
		<Liste>			::= [<Knoten>,<Knoten>,...]
		<Tupel>			::= (<Knoten>,<Knoten>,...)
		<Record> 		::= {<Bindung>,<Bindung>,...}
		<Bindung>		::= Bezeichner=<Knoten>
		<String>		::= "Zeichenfolge"
		<Zahl>			::= [1-9][0-9]* # mal als reg-exp :-)
		
		Diese Klasse enthaelt den Knoten, der auch als Wurzel des Baums betrachtet werden kann.
		
	create:
	date
	Fri Jun  1 16:08:31 MET DST 2001
		
    last mod: 
	date 
	Fri Jun  1 16:08:17 MET DST 2001
*/

// package parser;

import parseException;

import java.util.Vector;


class knoten extends Object{
	///////////////// MEMBER /////////////////////////////
	private int typ; // siehe Konstanten
	
	//// DATEN
	private int zahl;
	private String string;  // kann entweder wirklich die Zeichenfolge oder einen Bezeichner beinhalten
	private Vector kinder;  // sollten dann vom Typ knoten sein!
	
	///////////////// KONSTANTEN ///////////////////////////
	public static final int LEER = 1;
	public static final int KONSTRUKTOR = 2;
	public static final int BINDUNG = 3;
	public static final int LISTE = 4;
	public static final int TUPEL = 5;
	public static final int RECORD = 6;
	public static final int ZAHL = 7;
	public static final int STRING = 8;

	///////////////// DEKLARATIONEN /////////////////////////////

  //######Parst den String str und baut unterbaum auf.
	//  public String parse(String str) throws parseException;  
    //######Gibt den Baum auf der Konsole aus
    //  public void printBaum(int offset); 
    //  public int getTyp();
    //######Gibt Name zurueck im Fall von STRING, KONSTRUKTOR oder BINDING
    //  public String getName();
    //######Gibt Zahl zurueck im Fall ZAHL
    //  public int getZahl();
    //######Gibt Kind(er) zurueck in allen Faellen ausser ZAHL und STRING
    //  public Vector getKinder();
    //######Gibt Anzahl der Kinder zurueck
    //  public int getKinderZahl();
  
  //######Gibt nchstes Wort in str zurck.
  //  private  String getWort(String str)  
  //######Parst den String str und baut Vektor auf 
  //  private String LiesMenge(String str, int sollTyp) throws parseException;
  
	
	
	///////////////// DEFINITIONEN /////////////////////////////

	public knoten(){
	  kinder= new Vector();
      typ = 0;
	}
  
  
  
	// Parst den String str und baut unterbaum auf.
	// return: Restring
	//			null -> Fehler konnte nicht Parsen
  //      str -> habe nichts geparst
	//-----------------------------------------------------------------------	
	public String parse(String str) throws parseException {
	  int i, len;
    String teilstr,neu;
    int teilstrlen;
    boolean erfolg;
    knoten kind;
	
    str=str.trim();
		
    if(str.length() == 0){
//System.out.println("Leeren Knoten gefunden!");
      typ=LEER;
      return str;
    }
		  
		switch (str.charAt(0)){
			case '"':         ///////////// STRING   
        erfolg=false;
        len=str.length();
				for(i=1;i<len;i++){ // nach schliessendem " suchen
         
					if(str.charAt(i)=='\"' && str.charAt(i-1) != '\\'){
            erfolg=true;
            break;
          } 
				}
				if (!erfolg) throw new parseException("Kein schliessendes \" gefunden: " + str);
        
				string = str.substring(1,i);
				typ = STRING;
        str=str.substring(i+1);
//System.out.println("String gefunden: " + string);        
				break;
        
			case '(':               ///////////// TUPEL
        typ=TUPEL;
        neu = LiesMenge(str, 0); 
        neu=neu.trim();
        if( neu!=null && (neu=neu.trim())!=null && neu.charAt(0)== ')' ){
            str=neu.substring(1);
        }else{
          throw new parseException("Kein schliessende ) gefunden: " + str);          
        }
				break;
        
			case '[':               ///////////// LISTE
        typ=LISTE;
        neu = LiesMenge(str, 0); 
        neu=neu.trim();        
        if( neu!=null && (neu=neu.trim())!=null && neu.charAt(0)== ']' ){
            str=neu.substring(1);
        }else{
          throw new parseException("Kein schliessende ] gefunden: " + str);          
        }
				break;
        
			case '{':              ///////////// RECORD
        typ=RECORD;
        neu = LiesMenge(str, BINDUNG); 

        if( neu!=null && (neu=neu.trim())!=null && neu.charAt(0)== '}' ){
            str=neu.substring(1);
        }else{
          throw new parseException("Kein schliessende } gefunden: " + str);          
        }
        
				break;
        
			default:		// kann jetzt noch Zahl oder Konstruktor oder Bindung sein
        str=str.trim();        
        teilstr = getWort(str);
        teilstrlen = teilstr.length();
        if (teilstrlen==0){
//System.out.println("leerer Knoten: " + str);        
            typ=LEER;
            return str;
        }
        // Zahl	?
        if( Character.isDigit(teilstr.charAt(0))){
                    
          try{
             zahl = (new Integer(teilstr)).intValue();
          }catch(NumberFormatException e){
             throw new parseException("Kann nicht in Zahl konvertieren: " + teilstr);        
          }
          typ=ZAHL;
          str=str.substring(teilstrlen);
//System.out.println("Zahl gefunden: " + zahl);        
        }else{
          // Bindung oder Konstruktor ? 
          erfolg=false;
          len=str.length();
          for(i=teilstrlen;i<teilstrlen + 10 && i < len;i++){
            if( !Character.isWhitespace(str.charAt(i)) && !Character.isLetterOrDigit(str.charAt(i))){
                if(str.charAt(i)== '='){
                  erfolg=true;  
                  break;
                }else{
                  break;
                }
            }
          }
          
          if(erfolg){   //////////////// BINDUNG
            typ=BINDUNG;
            string=teilstr;
//System.out.println("Bindung: " + teilstr);            
            // so Nun noch Kind dran            
          str=str.substring(i+1);
          kind=new knoten();
          neu=kind.parse(str);
          
          kinder.insertElementAt(kind,0);
          if (neu == null){
             throw new parseException("Wertzuweisung nicht mglich: " + str);        
          }
          str=neu.trim();
                      
          }else{      //////////////// KONSTUKTOR
          
            typ=KONSTRUKTOR;
            string=teilstr;
//System.out.println("Konstruktor: " + teilstr); 
            // so Nun noch Kind dran            
            str=str.substring(teilstrlen);
            kind=new knoten();
            neu=kind.parse(str);
            
            kinder.insertElementAt(kind,0);
            if (neu == null){
               throw new parseException("Knoten nach Kunstruktor unklar: " + str);        
            }
              str=neu.trim();

            }
        }
				break;
		
		
		}

		return str;
	}
  
  
  
  // Gibt den Baum auf der Konsole aus
  // Param: offset   : Spalte in der es los geht
  //        nulloffset : in dieser Spalte keinen Offset machen
	// return:
	//-----------------------------------------------------------------------	
  public void printBaum(int offset, boolean nulloffset){
      int i;
      final int step=2;
      
      if (!nulloffset){
        for(i=0;i<offset-step;i++) {
            System.out.print(" ");
        }
        if(offset>step) System.out.print("|-");
      }
      nulloffset=false;
      switch(typ){
        case LEER:
          System.out.println("#leer#");
          return;
        case ZAHL:
          System.out.println(zahl);
          return;
        case STRING:
          System.out.println("\"" + string + "\"");
          return;
        case KONSTRUKTOR:
          System.out.print(string + " ");
          offset=offset+string.length()+1;
          nulloffset=true;
          break;
        case BINDUNG:
          System.out.print(string + "= ");
          offset=offset+string.length()+1;
          nulloffset=true;          
          break;
        case LISTE:
          System.out.println("#Liste#");
          break;  
        case TUPEL:
          System.out.println("#Tupel#");
          break;  
        case RECORD:
          System.out.println("#Record#");
          break;                      
      }
      
      for(i=0;i<kinder.size();i++){
        ((knoten)kinder.elementAt(i)).printBaum(offset+step, nulloffset);
      }
     
  }
  
  
  
    // Gibt Typ zurueck
	// return: typ
	//		   0 noch nicht initialisiert
	//-----------------------------------------------------------------------	
    public int getTyp(){
      return typ;
    }
    
    // Gibt Name zurueck im Fall von STRING, KONSTRUKTOR oder BINDING
	// return: Name des Objects
	//		   null noch nicht initialisiert oder falscher Typ
	//-----------------------------------------------------------------------	
    public String getName(){
      if(typ==BINDING || typ == KONSTRUKTOR || typ == STRING) return string;
      else return null;
    }

    // Gibt Zahl zurueck im Fall ZAHL
	// return: zahl
	//		   -1 noch nicht initialisiert oder falscher Typ
	//-----------------------------------------------------------------------	
    public int getZahl(){
      if(typ==ZAHL) return zahl;
      else -1;
    }
    
    // Gibt Kind(er) zurueck in allen Faellen ausser ZAHL und STRING
	// return: kinder als Vector
	//		   null: noch nicht initialisiert oder falscher Typ
	//-----------------------------------------------------------------------	
    public Vector getKinder(){
      if(typ!=0 && typ!= ZAHL && typ!=STRING ) return kinder;
      else null;
    }
    
    // Gibt Anzahl der Kinder zurueck
	// return: anzahl
	//		   0 noch nicht initialisiert oder falscher Typ oder leer
	//-----------------------------------------------------------------------	
    public int getKinderZahl(){
      return kinder.size();
    }

///////////////////////////////////////////// PRIVATE //////////////////////////////

    // Gibt naechstes Wort in str zurueck.
	// return: wort
	//			   Null Fehler
	//-----------------------------------------------------------------------	
	private  String getWort(String str){
    int i,len = str.length();    
        
    for( i=0; i< len; i++){
      if(!Character.isLetterOrDigit(str.charAt(i))){
        break;
      }
    }
    if(i==len) return str;
    else return str.substring(0,i);
    
  }
	
  // Parst den String str und baut Vektor auf 
  // Param: string, typ der Elemente in der From (knoten,knoten,...) (klammern ist egal welche)
  //                  ==0 -> jeder Typ
  //                  !=0 -> nur der Typ zugelassen
	// return: Rest-String
	//			   null -> Fehler konnte nicht Parsen
	//-----------------------------------------------------------------------	
  private String LiesMenge(String str, int sollTyp) throws parseException {
    
     String neu;
     knoten kind;
     boolean neueKinder=true;
     
     
     // WhiteSpaces am Anfang zhlen
    str=str.trim();
    if( Character.isLetter(str.charAt(0))){
      return null;
    }
    

     while(neueKinder){
       //!!! Achtung hier mu noch auf leere Liste und Leere params getestet werden

        // jetzt eigentliche Kinder hinzufeegen

        kind=new knoten();
        neu=kind.parse(str.substring(1));
        if (neu == null){
           throw new parseException("Listenelement unklar: " + str);        
        }
        if(sollTyp != 0 && kind.typ != sollTyp ){
           throw new parseException("Listenelement ist vom falschen Typ: " + str);                  
        }

        kinder.addElement(kind);
        str=neu.trim();
        // Jetzt muss , oder Klammern kommen
        if(str.charAt(0)== ','){ // es geht weiter
          neueKinder=true;
        }else{
          neueKinder=false;
        }        
     }
          
     return str;
  }



}



